/*
  Copyright 1998 NOKUBI Takatsugu

$Id: Kakasi.xs,v 1.1 1999/01/11 07:55:14 knok Exp $
*/

#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#ifdef __cplusplus
}
#endif

#include <stdio.h>
#include "kakasi.h"

#define KAKASIBUF 256

extern int romaji_type;
extern int romaji_capitalize;
extern int romaji_upcase;
extern int heiki_mode;
extern int bunkatu_mode;
extern int furigana_mode;
extern int cr_eat_mode;
extern int flush_mode;
#ifdef WAKATIGAKI
extern int wakatigaki_mode;
#endif /* WAKATIGAKI */

extern int kanji_digest;
extern int separator_out;
extern char cr_eat_string[KAKASIBUF];
extern Character n[KAKASIBUF];

extern input_term_type, output_term_type;

extern FILE *kanwadict;

void digest_start_copy();
void put_separator();
void putchars();
void digest_out();
int digest();
void digest_shift();

void setcharbuffer();
char *getpbstr();

static int (*proc[8])()={NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL};
    /* ASCII, JISROMAN, KATAKANA, GRAPHIC, ѵ, ѥ, Ѥ,  */

Character c[KAKASIBUF], r[KAKASIBUF];
int clen, ptype, pctype;

MODULE = Text::Kakasi		PACKAGE = Text::Kakasi

int
getopt_argv(sv,...)
    SV* sv

    PREINIT:
	int i;
	char **cargv, **argv;
	int argc;

    CODE:
	RETVAL = 0;
	argc = items;
	cargv = (char **) malloc(sizeof(char *) * items + 1);
	for (i = 0; i <= items; i ++) {
	    cargv[i] = SvPV(ST(i), na);
	}
	cargv[items] = NULL;
	argv = cargv;
    while(--argc > 0) {
	++ argv;
	if ((*argv)[0] != '-') break;
	switch((*argv)[1]) {
	  case 'a':
	    switch((*argv)[2]) {
	      case 'j':	proc[0] = a2j; break;
	      case 'E':	proc[0] = a2E; break;
	      default:  proc[0] = NULL;
	    }
	    break;
	  case 'j':
	    switch((*argv)[2]) {
	      case 'a':	proc[1] = j2a; break;
	      case 'E':	proc[1] = j2E; break;
	      default:  proc[1] = NULL;
	    }
	    break;
	  case 'g':
	    switch((*argv)[2]) {
	      case 'a':	proc[2] = g2a; break;
	      case 'j':	proc[2] = g2j; break;
	      case 'E':	proc[2] = g2E; break;
	      default:  proc[2] = NULL;
	    }
	    break;
	  case 'k':
	    switch((*argv)[2]) {
	      case 'a':	proc[3] = k2a; break;
	      case 'j':	proc[3] = k2j; break;
	      case 'K':	proc[3] = k2K; break;
	      case 'H':	proc[3] = k2H; break;
	      default:  proc[3] = NULL;
	    }
	    break;
	  case 'E':
	    switch((*argv)[2]) {
	      case 'a':	proc[4] = E2a; break;
	      case 'j':	proc[4] = E2j; break;
	      default:  proc[4] = NULL;
	    }
	    break;
	  case 'K':
	    switch((*argv)[2]) {
	      case 'a':	proc[5] = K2a; break;
	      case 'j':	proc[5] = K2j; break;
	      case 'k':	proc[5] = K2k; break;
	      case 'H':	proc[5] = K2H; break;
	      default:  proc[5] = NULL;
	    }
	    break;
	  case 'H':
	    switch((*argv)[2]) {
	      case 'a':	proc[6] = H2a; break;
	      case 'j':	proc[6] = H2j; break;
	      case 'k':	proc[6] = H2k; break;
	      case 'K':	proc[6] = H2K; break;
	      default:  proc[6] = NULL;
	    }
	    break;
	  case 'J':
	    switch((*argv)[2]) {
	      case 'a':	proc[7] = J2a; break;
	      case 'j':	proc[7] = J2j; break;
	      case 'k':	proc[7] = J2k; break;
	      case 'K':	proc[7] = J2K; break;
	      case 'H':	proc[7] = J2H; break;
	      default:  proc[7] = NULL;
	    }
	    break;
	  case 'i':
	    if ((*argv)[2] != '\0')
		set_input_term(term_type_str((*argv)+2));
	    else
		if (argc > 0) {
		    -- argc;
		    set_input_term(term_type_str(*(++ argv)));
		}
	    break;
	  case 'o':
	    if ((*argv)[2] != '\0')
		set_output_term(term_type_str((*argv)+2));
	    else
		if (argc > 1) {
		    -- argc;
		    set_output_term(term_type_str(*(++ argv)));
		}
	    break;
	  case 'r':
	    if ((*argv)[2] == 'k')
		romaji_type = KUNREI;
	    break;
	  case 'p':
	    heiki_mode = 1;
	    break;
	  case 's':
	    bunkatu_mode = 1;
	    break;
	  case 'f':
	    furigana_mode = 1;
	    break;
	  case 'c':
	    cr_eat_mode = 1;
		sprintf(cr_eat_string, "\011\012\015 %s", (*argv)+2);
	    break;
	  case 'C':
	    romaji_capitalize = 1;
	    break;
	  case 'U':
	    romaji_upcase = 1;
	    break;
	  case 'u':
	    flush_mode = 1;
	    break;
#ifdef WAKATIGAKI
	  case 'w':
	    wakatigaki_mode = 1;
	    bunkatu_mode = 1;
	    proc[5] = K2K;
	    proc[6] = H2H;
	    proc[7] = J2H;
	    break;
#endif /* WAKATIGAKI */
	  default:
	    RETVAL = 1;
	}
    }
    if ((input_term_type != UNKNOWN) && (output_term_type == UNKNOWN))
	set_output_term(input_term_type);
    if (proc[7] != NULL) {
	init_jisyo();
	init_kanwa();
	for (; argc > 0; -- argc)
	    add_jisyo(*(argv ++));
    }
	free(cargv);

    OUTPUT:
	RETVAL

SV*
do_kakasi(sv)
	SV *sv

    PREINIT:
	char *tmp;

    CODE:
	tmp = SvPV(sv, na);
	setcharbuffer(tmp);
    pctype = OTHER;
    separator_out = 0;
    for(;;) {
	getkanji(c);
	if ((c[0].type == OTHER) && (c[0].c1 == 0xff)) break;
	c[1].type = OTHER;
	c[1].c1 = '\0';
	clen = 1;
	while (clen > 0) {
	    kanji_digest = 0;
	    switch (c[0].type) {
	      case ASCII:
	      case JISROMAN:
	      case GRAPHIC:
	      case KATAKANA:
		if ((c[0].type != OTHER) && (c[0].type != pctype)) {
		    put_separator();
		    pctype = c[0].type;
		}
		if ((*proc[(int)(c[0].type)]) == NULL) {
		    putkanji(c); digest_shift(c, 1); -- clen;
		    if (flush_mode) fflush(stdout);
		} else {
		    digest_start_copy(c, r);
		    clen = digest(c, clen, r, clen, (int)(c[0].type), *proc[(int)(c[0].type)]);
		}
		break;
	      case JIS83:
		if (c[0].c1 >= 0xb0) {
		    ptype = 7;
		    kanji_digest = 1;
#ifdef WAKATIGAKI
		} else if ((c[0].c1 == 0xa1) && /* ,, */
			   (c[0].c2 >= 0xb8 && c[0].c2 <= 0xba)) {
		    ptype = 7;
		    kanji_digest = 1;
		} else if ((c[0].c1 == 0xa5) && /*  */
			   (c[0].c2 >= 0xf5 && c[0].c2 <= 0xf6)) {
		    ptype = 7;
		    kanji_digest = 1;
#endif /* WAKATIGAKI */
    		} else if (c[0].c1 == 0xa4) {
		    ptype = 6;
#ifdef WAKATIGAKI
		} else if ((c[0].c1 == 0xa1) && /* ,,, */
			   (c[0].c2 >= 0xb3 && c[0].c2 <= 0xb6)) {
		    ptype = 6;
#endif /* WAKATIGAKI */
		} else if (c[0].c1 == 0xa5) {
		    ptype = 5;
		} else if ((c[0].c1 == 0xa1) && (c[0].c2 == 0xbc)) {
		    ptype = 5;
		} else {
		    ptype = 4;
		}
		if (ptype != pctype) {
		    put_separator();
		    pctype = ptype;
		}
		if ((*proc[ptype]) == NULL) {
		    putkanji(c); digest_shift(c, 1); -- clen;
		    if (flush_mode) fflush(stdout);
		} else {
		    digest_start_copy(c, r);
		    clen = digest(c, clen, r, clen, JIS83, *proc[ptype]);
		}
		break;
	      default:
		putkanji(c); digest_shift(c, 1); -- clen;
/*		if (flush_mode) fflush(stdout);*/
	    }
	}
    }

	tmp = getpbstr();
	if (tmp != NULL) {
		RETVAL = newSVpv(tmp, 0);
		free(tmp);
	} else {
		RETVAL = newSVpv("", 0);
	}

    OUTPUT:
	RETVAL

int
close_kanwadict()

    CODE:
	RETVAL = 1;
	if (kanwadict != NULL) {
		fclose(kanwadict);
		kanwadict = NULL;
		RETVAL = 0;
	}

    OUTPUT:
	RETVAL
